# $Id: Template.pm,v 1.2 2003/03/22 07:33:24 struan Exp $
package Foo2Mail::Template;

use strict;
use warnings;
use Foo2Mail;
use Template;

use base qw(Foo2Mail);

BEGIN {
    our ( $VERSION, $ERROR );
    $VERSION = 0.01;

    # ooooh, this is nasty :(
    *ERROR = *Foo2Mail::ERROR;
}

=head1 NAME

Foo2Mail::Template

=head1 SYNOPSIS

    use Foo2Mail::Template;
    # see Foo2Mail for rest

=head1 DESCRIPTION

Very simple example of overriding the email formatting for Foo2Mail.

=head1 AUTHOR

Struan Donald
<modules@exo.org.uk>
http://www.exo.org.uk/code/

=head1 COPYRIGHT

Copyright (C) 2002 Struan Donald. All rights reserved.

This program is free software; you can redistribute
it and/or modify it under the same terms as Perl itself.

The full text of the license can be found in the
LICENSE file included with this module.

=head1 SEE ALSO

perl(1), Foo2Mail.

=cut

sub format {
    my $self = shift;
    my $mail = shift;
    
    my $tt = Template->new() or $self->fatal_error('Cannot init Template');
   
    # we have to seek back to the beginning of DATA otherwise 
    # after the first call to template we start from end of DATA
    seek(*Foo2Mail::Template::DATA,0,0);
    
    my $body;
    
    $tt->process(
            \*Foo2Mail::Template::DATA, 
            {info => $mail}, 
            \$body
    ) or $self->fatal_error("Template problem");

    $body;
}

1;

__DATA__

[% FOR section = info.sections -%]
[% IF section.name -%]
[% section.name %]
-----------------------------------------------------------------------
[% END -%]
[% FOR entry = section.items -%]
[% entry.id %] : [% entry.content %]
[% END -%]
[% END -%]
