# $Id: 002_check_init.t,v 1.1.1.1 2003/01/10 00:08:09 struan Exp $

# NB have to test that no_send or no_auto are set to true in different instances
# in order to prevent any email being sent.

use Test::More tests => 20;
use Foo2Mail;

my $f2m = Foo2Mail->new(
    fetch       =>  sub { my ($self, $name, $target) = @_;
                          return {
                            name    =>  $name,
                            id      =>  $target,
                            content =>  'content'
                          };
                        },
    to_fetch    =>  { name  =>  'target' },
    to          =>  'user@example.com',
    no_send     =>  1,
   );

is($f2m->{fetch}->()->{content},  'content',    'fetch method set');
is_deeply($f2m->{to_fetch},    { name  =>  'target' },       'to_fetch set');
is($f2m->{to}->[0],     'user@example.com',     'to address set');
is($f2m->{from},        'f2m@exo.org.uk',       'default from address set');
is($f2m->{subject},     'Content from Foo2Mail','default subject set');
is($f2m->{base_dir},    './.foo2mail',          'default base_dir set');
is($f2m->{delete_after},       30,              'default days_to_store set');
ok(!$f2m->{no_auto},                            'default no_auto set');
ok($f2m->{no_send},                             'no_send set');
ok(!$f2m->{include_errors},                     'default include_errors ok');
ok($f2m->{warn_errors},                         'default warn_errors ok');

undef $f2m;

my $f2m2 = Foo2Mail->new(
    fetch           =>  sub { return 'fetch method' },
    to_fetch        =>  { name  =>  'target' },
    to              =>  'user@example.com',
    from            =>  'f2m@example.com',
    subject         =>  'you have mail from f2m',
    base_dir        =>  't/test',
    delete_after    =>  10,
    item_delete_after   =>  { name  =>  35 },
    no_auto         =>  1,
    include_errors  =>  1,
    warn_errors     =>  0,
   );


is($f2m2->{from},        'f2m@example.com',        'from address set');
is($f2m2->{subject},     'you have mail from f2m',  'subject set');
is($f2m2->{base_dir},    't/test',                  'base_dir set');
is($f2m2->{delete_after},        10,                'days_to_store set');
is_deeply($f2m2->{item_delete_after},{ name  =>  35 },'days_to_store set');
ok($f2m2->{no_auto},                                'no_auto set');
ok(!$f2m2->{no_send},                               'default no_send set');
ok($f2m2->{include_errors},                         'include_errors ok');
ok(!$f2m2->{warn_errors},                           'include_errors ok');
