# $Id: 003_check_processing.t,v 1.1.1.1 2003/01/10 00:08:09 struan Exp $

use Test::More tests => 4;
use Foo2Mail;

my @mail1;

sub slurp {
    my $path = shift;
    open FILE, "<$path"; 
    if (wantarray) {
        my @data = <FILE>; close FILE; return @data;
    } else {
        my $data = join('',<FILE>); close FILE; return $data;
    }
}

@mail1 = grep { ! /^Date:/ } slurp('t/data/mail1.dat');

foreach my $dir (glob 't/test/*') {
    unlink <$dir/*>;
    rmdir $dir;
}

sub fetch {
    my ($self, $name, $target) = @_;

    local $\ = undef;
    open FILE, "<$target" or die "couldn't open $target: $!";
    my $foo = <FILE>;
    close FILE;

    return {
        name    =>  $name,
        content =>  $foo,
        id      =>  $target,
    };
}

my %to_fetch = (
    test1   =>  't/data/test1.dat',
    test2   =>  't/data/test2.dat',
    test3   =>  't/data/test3.dat',
);

my $f2m = Foo2Mail->new(
    fetch           =>  \&fetch,
    to_fetch        =>  \%to_fetch,
    to              =>  'user@example.com',
    base_dir        =>  't/test',
    no_send         =>  1,
    include_errors  =>  1,
    warn_errors     =>  0,
   );

my $email = $f2m->get_email();
my @email = grep { ! /^Date:/ and ! /^X\-Mailer/ } split( /^/, $email);

is(join('', @email), join('', @mail1), 'correct email');

$f2m->store();

my $f2m2 = Foo2Mail->new(
    fetch           =>  \&fetch,
    to_fetch        =>  \%to_fetch,
    to              =>  'user@example.com',
    base_dir        =>  't/test',
    no_send         =>  1,
    include_errors  =>  1,
    warn_errors     =>  0,
   );

$email = $f2m2->get_email();
ok(!$email,                             'no email without new content');


my $time = time - (60 * 60 * 24 * 31);
utime $time, $time, 't/test/test3/t_data_test3.dat';

is(join('',glob('t/test/test3/*')), 't/test/test3/t_data_test3.dat', 'Files before cleanup');

$f2m->cleanup();

is(join('',glob('t/test/test3/*')), '', 'No files after cleanup');
